/**
 * This file was auto-generated by the Titanium Module SDK helper for Android
 * Appcelerator Titanium Mobile
 * Copyright (c) 2009-2013 by Appcelerator, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License
 * Please see the LICENSE included with this distribution for details.
 *
 */
package tv.wappzapp.html5video;

import org.appcelerator.kroll.KrollDict;
import org.appcelerator.kroll.KrollProxy;
import org.appcelerator.kroll.annotations.Kroll;
import org.appcelerator.titanium.TiC;
import org.appcelerator.titanium.util.Log;
import org.appcelerator.titanium.util.TiConvert;
import org.appcelerator.titanium.TiContext.OnLifecycleEvent;
import org.appcelerator.titanium.proxy.TiViewProxy;
import org.appcelerator.titanium.view.TiCompositeLayout;
import org.appcelerator.titanium.view.TiCompositeLayout.LayoutArrangement;
import org.appcelerator.titanium.view.TiUIView;
import org.itri.html5webview.*;

import android.app.Activity;

// This proxy can be created by calling Html5video.createExample({message: "hello world"})
@Kroll.proxy(creatableInModule=Html5videoModule.class)
public class WebVideoProxy extends TiViewProxy/* implements OnLifecycleEvent*/ {
	// Standard Debugging variables
	private static final String TAG = "HTML5AndroidVideo";
	
	HTML5WebView html5webview;
	String url;
	TiUIView view;
	
	private class WebVideoView extends TiUIView
	{
		public WebVideoView(TiViewProxy proxy) {
			super(proxy);
			LayoutArrangement arrangement = LayoutArrangement.DEFAULT;

			if (proxy.hasProperty(TiC.PROPERTY_LAYOUT)) {
				String layoutProperty = TiConvert.toString(proxy.getProperty(TiC.PROPERTY_LAYOUT));
				if (layoutProperty.equals(TiC.LAYOUT_HORIZONTAL)) {
					arrangement = LayoutArrangement.HORIZONTAL;
				} else if (layoutProperty.equals(TiC.LAYOUT_VERTICAL)) {
					arrangement = LayoutArrangement.VERTICAL;
				}
			}
			
			html5webview = new HTML5WebView(proxy.getActivity());
			html5webview.loadUrl(url);
			setNativeView(html5webview.getLayout());
		}

		@Override
		public void processProperties(KrollDict d)
		{
			super.processProperties(d);
		}
	}

	// Constructor
	public WebVideoProxy()
	{
		super();
	}

	@Override
	public TiUIView createView(Activity activity)
	{
		view = new WebVideoView(this);
		view.getLayoutParams().autoFillsHeight = true;
		view.getLayoutParams().autoFillsWidth = true;
		return view;
	}

	// Handle creation options
	@Override
	public void handleCreationDict(KrollDict options)
	{
		super.handleCreationDict(options);
		if (options.containsKey("url")) {
			url = (String) options.get("url");
			//html5webview.loadUrl(url);
		}
	}
	
	@Kroll.setProperty @Kroll.method
	public void setUrl(String _url) {
		url = _url;
		html5webview.loadUrl(url);
	}
	

	/*public void onPause(Activity activity) {
	}

	public void onResume(Activity activity) {
	}

	public void onStart(Activity activity) {
		//super.onStart(activity);
	}

	public void onStop(Activity activity) {
		//super.onStop(activity);

		html5webview.destroy();
		//html5webview.destroyDrawingCache();
		html5webview = null;
		
		//view.destroyDrawingCache();
		//view = null;
	}

	public void onDestroy(Activity arg0) {

	}*/
	
}